/*
 * medias.h
 *
 * Used paper formats
 * Copyright (c) 1988, 89, 90, 91, 92, 93 Miguel Santana
 * Copyright (c) 1995, 96, 97 Akim Demaille, Miguel Santana
 * $Id: medias.h,v 1.2 1997/04/06 15:17:13 demaille Exp $
 */

/*
 * This file is part of a2ps.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _MEDIAS_H_
#define _MEDIAS_H_

#include "config.h"

/* Definition of the medias available */
typedef struct media {
  char * name;
  int w;
  int h;
  int llx;
  int lly;
  int urx;
  int ury;
} media;

/* Possible orientations */
typedef enum {
  portrait, landscape
} ORIENTATION;

extern media medias[];
extern int nbr_medias;

int select_media PARAMS ((char *string));

#endif
