/*
 *		Eiffel
 */
const sequence eiffel_sequences [] = {
  a2_line_sequences(COMMENT, --),
  a2_sequence(\", PLAIN, string, \", PLAIN),
  a2_sequence(\', PLAIN, string, \', PLAIN),
  ENDSEQUENCE
};
const uchar* eiffel_verbatims [] = {
  (ustring) "%%", (ustring) "%\"", (ustring) "%'", UNULL
};
const uchar eiffel_characters [] = {
  'A', 'Z',
  'a', 'z',
  '_', '_',
  '\0'
};
const symbol eiffel_regulars [] = {
  a2_not_symbol(or else, keyword_strong),
  a2_not_symbol(and then, keyword_strong),
  a2_not(not), a2_or(or), a2_and(and), a2_imply(implies),
  ENDSYMBOL
};
const symbol eiffel_specials [] = {
  a2_not_symbol(:=, PLAIN),
  a2_equiv(=),
  a2_neq(/=),
  a2_leq(<=),
  a2_geq(>=),
  ENDSYMBOL
};
const keyword eiffel_keywords [] = {
  /* keywords */
  a2_keyword(KEYWORD_STRONG, all, alias, as, and, check, class,
current, debug, deferred, do, else, elseif, end, ensure, expanded,
export, external, false, feature, from, if, implies, indexing, infix,
inherit, inspect, invariant, is, language, like, local, loop, none,
not, creation, obsolete, old, once, or, prefix, redefine, require,
rename, rescue, result, retry, select, separate, strip, then, true,
undefine, unique, until, variant, void, when, xor)

   /* some basic types */
 a2_keyword(KEYWORD, bit, boolean, character, double, integer, pointer,
real, string)
   ENDKEYWORD
};
const char * eiffel_abbreviations [] = {
  "e", "\0"
};
const uchar  eiffel_description [] = "";
#define eiffel_style_def { eiffel_style, "eiffel",			\
  eiffel_abbreviations, eiffel_description, 				\
  CASE_INSENSITIVE, eiffel_characters,	eiffel_characters,		\
  eiffel_keywords,                                                     	\
  eiffel_regulars, eiffel_specials, eiffel_sequences, EMPTY, eiffel_verbatims }

/*
 *		Language of Assembly for Classes of Eiffel
 */
const keyword lace_keywords [] = { 
  /* keywords */
  a2_keyword(KEYWORD_STRONG, end, system, root, cluster, use, include,
precompiled, exclude, adapt, ignore, rename, as, default, option,
collect, assertion, debug, optimize, trace, yes, no, all, require,
ensure, invariant, loop, check, external, object, make, generate,
visible, creation, export)

   /* Languages */
  a2_keyword(KEYWORD, eiffel, ada, pascal, fortran, c)
   ENDKEYWORD
};
const char * lace_abbreviations [] = {
  "ace", "\0"
};
const uchar  lace_description [] = "";
#define lace_style_def { lace_style, "lace",				\
  lace_abbreviations, lace_description, 				\
  CASE_INSENSITIVE, eiffel_characters, eiffel_characters,		\
  lace_keywords, NOSYMBOL, NOSYMBOL, eiffel_sequences, EMPTY, eiffel_verbatims }
